library CoreDispather;

import '../router/Router.dart';
import 'dart:html';
import 'dart:async';
import  '../contracts/Renderable.dart';

part  '../contracts/DispatherInterface.dart';

class BasicDispather implements DispatherInterface {
  RouterInterface _router;
  String  _defaultRoute;
  
  BasicDispather(RouterInterface router, String droute) {
    this._router = router;
    this._defaultRoute = droute;
  }
  
  void  redirect(String hash) { 
    this._overwriteHash(hash); 
  }
  
  void dispath() {
    String hash = this._getHash();
    // Handle page request
    if(this._router.routeExists(hash)) this._router.render(hash);
    else if(this._defaultRoute.isNotEmpty && hash.isEmpty) this._router.render(this._defaultRoute);
    else this.redirect404();
  }
  
  void  listen() {
    window.onHashChange.listen((event) {
      this.dispath();
    });
  }
  
  void  _overwriteHash(String hash) { 
    window.location.hash = "${hash}"; 
  }
  
  void  redirect404() {
    this.redirect("404");
    this._router.render("404");
  }
  
  String _getHash() {
    if(window.location.hash.isEmpty) return "";
    // Aim = "#" -> as good as empty 
    else if(window.location.hash.length == 1) return "";
    else {
      String hash = window.location.hash;
      return hash.substring(1, hash.length);
    }  
  }
}