library CoreRoute;

import '../view/CoreView.dart';
import 'dart:async';
import '../contracts/Renderable.dart';

part '../contracts/Route/RouteInterface.dart';
part '../contracts/Route/BasicRouteInterface.dart';

part '../contracts/Route/ComplexRouteInterface.dart';
part 'ComplexRoute.dart';

class BasicRoute implements BasicRouteInterface {
  Renderable _view;
  Function _viewDataSource;
  
  BasicRoute(Renderable view) {
    this._view = view;
  }
  
  void viewDataSource(Function routine) {
    this._viewDataSource = routine;
  }
  
  Future<String> render() async {
    return await this._view.render();
  }
  
  /* Interface implementatation */
  Renderable getView() async => this._view;
}



