/* Is reponsible for providing an module to manage routes. */
library CoreRouter;

import 'dart:html';
import 'dart:async';
import 'package:domquery/utils.dart';
import '../route/Route.dart';
import '../view/CoreView.dart';

part '../contracts/RouterInterface.dart';

class BasicRouter implements RouterInterface {
  Map<String, RouteInterface> _routes;
  
  BasicRouter() {
    this._routes = new Map<String, RouteInterface>();
  }
  
  void addRoute(String url, RouteInterface route) {
    this._routes.putIfAbsent(url, () => route);
  }
  
  bool routeExists(String url) {
    return this._routes.containsKey(url);
  }
  
  render(String url) async {
    if(this._routes.containsKey(url))
    {
      var output = await this._routes[url].render();
      domQuery('body').html(output);
    }
    else domQuery('body').html('The homepage route "${url}" doesn\'t exist yet. The following routes(${this._routes.keys.length}) do exist: ${this._routes.keys.join(', ')}');
  }
}