part of CoreView;

/**
 * Does support aync rendering;
 * Doesn't support content pulling;
 * Doesn't support data pulling;
 */
class ComplexView extends ViewBag {
  Map<String, Renderable> _content;
  String _scope;
  
  ComplexView(Map content) {
    this._content = content;
  }
  
  Map getContent() => this._content;
  Renderable setContent(Map content) {
    this._content = content;
    return this;
  }
  
  void  setScope(String selector) { this._scope = selector; }
  String  getScope() => this._scope;
    
  void  put(String key, Renderable view) { this._content.putIfAbsent(key, () => view); }
  Renderable  get(String key) => this._content[key];
      
  Future<String> render() async {
    List output = new List();
    await Future.forEach(this._content.values, (Renderable view) async {
      String source = await view.render();
      output.add(source);
    });
    return output.join("\n");
  }
}