library CoreView;

import 'package:mustache/mustache.dart' as mustache;
import 'dart:html';
import 'dart:async';
import '../contracts/Content.dart';
import '../contracts/Renderable.dart';
import '../contracts/Puller.dart';
import '../contracts/Bag.dart';
import '../contracts/Resource.dart';

part '../contracts/View/DataView.dart';
part '../contracts/View/StaticView.dart';
part '../contracts/View/View.dart';
part '../contracts/View/ViewBag.dart';
part 'MustacheView.dart';
part 'ComplexView.dart';
part 'UrlView.dart';


class BasicView extends View {
  String  _content;
  String  _scope;
  
  BasicView(String content) { this._content = content; }
  
  void  setScope(String selector) { this._scope = selector; }
  String  getScope() => this._scope;
  
  String getContent() => this._content;
  Renderable setContent(String content) {
    this._content = content;
    return this;
  }        
          
  Future<String>  render() async {
    return this._content;
  }
}