import 'dart:math' as Math;
import 'lib/dispather/Dispather.dart';
import 'lib/view/CoreView.dart'; 
import 'lib/route/Route.dart';
import 'lib/router/Router.dart';
import 'dart:html';
import 'dart:core';
import 'lib/contracts/Renderable.dart';

void main() {
  RouterInterface router = new BasicRouter();
  Renderable index = new ComplexView({
    'menu': new UrlView('/views/stanley_theme/menu.html'),
    'index':  new UrlView('/views/stanley_theme/index.html')
  });
  
  Renderable about = new ComplexView({
      'menu': new UrlView('/views/stanley_theme/menu.html'),
      'index':  new UrlView('/views/stanley_theme/about.html')
    });
  
  Renderable work = new ComplexView({
      'menu': new UrlView('/views/stanley_theme/menu.html'),
      'index':  new UrlView('/views/stanley_theme/work.html')
    });
  
  Renderable blog = new ComplexView({
      'menu': new UrlView('/views/stanley_theme/menu.html'),
      'index':  new UrlView('/views/stanley_theme/blog.html')
    });
  
  Renderable contact = new ComplexView({
      'menu': new UrlView('/views/stanley_theme/menu.html'),
      'index':  new UrlView('/views/stanley_theme/contact.html')
    });
  
  router..addRoute("index", new BasicRoute(index))
        ..addRoute("about", new BasicRoute(about))
        ..addRoute("blog", new BasicRoute(blog))
        ..addRoute("work", new BasicRoute(work))
        ..addRoute("contact", new BasicRoute(contact));
  
  // "index" -> default view to load
  DispatherInterface disp = new BasicDispather(router, "index");
      disp..listen()
          ..dispath();
}